/* dmp2bin.c */
/* conversion fichier dump HP75 en fichier pour mon75 */



#include <stdio.h>



int hextoint(char c)
{
  if (c>='a') c -= 32;
  if (c>'9') c -= 7;
  c -= 48;
  return(c);
}





void conv(char *nomsrc, char *nomdest)
{
  FILE *src;
  FILE *dest;
  char ligne[82];
  unsigned char buffer[32];
  int i, n;
  int nu_ligne;
  char *pt_src;
  unsigned char *pt_dest;

  src=fopen(nomsrc,"rt");
  if (src==NULL) {
    printf("erreur: fichier %s non trouv\n",nomsrc);
    exit(0);
  }
  dest=fopen(nomdest,"wb");
  if (dest==NULL) {
    printf("erreur: impossible de crer %s\n",nomdest);
    exit(0);
  }

  for (nu_ligne=0;;nu_ligne++) {
    if (fgets(ligne,80,src)==NULL) break;
    pt_src=ligne;
    pt_dest=buffer;
//    pt_src++;  /* pour rdump 2me version (?() */
    for (i=0;i<32;i++) {
//      n = ((*pt_src++)-48)<<4;
//      n+= (*pt_src++)-48;
      n = hextoint(*pt_src++) <<4;
      n+= hextoint(*pt_src++);
      *pt_dest++ = n;
    }
    fwrite(buffer,1,32,dest);
  }
  fclose(dest);
  fclose(src);
}



void main(int argc, char *argv[])
{
  if (argc<3) {
    printf("erreur: pas assez d'arguments\n");
    exit(0);
  }
  conv(argv[1],argv[2]);
}
